summaryrefslogtreecommitdiffstats
path: root/mixxx
diff options
context:
space:
mode:
author Eric Hameleers <alien@slackware.com>2020-06-29 19:34:32 +0000
committer Eric Hameleers <alien@slackware.com>2020-06-29 19:34:32 +0000
commitb308a76b1e819124d1e1506d16ce3e4e1087ad51 (patch)
treea70cd510f44930825af42f44ca7a0a695cc1adf3 /mixxx
parent974ed694c84667602f84a0602a72a62f17673006 (diff)
downloadasb-b308a76b1e819124d1e1506d16ce3e4e1087ad51.tar.gz
asb-b308a76b1e819124d1e1506d16ce3e4e1087ad51.tar.xz
Initial revision
Diffstat (limited to 'mixxx')
-rwxr-xr-xmixxx/build/mixxx.SlackBuild257
-rw-r--r--mixxx/build/patches/mixxx_list-fix.patch27
-rw-r--r--mixxx/build/slack-desc19
-rw-r--r--mixxx/build/slack-required13
4 files changed, 316 insertions, 0 deletions
diff --git a/mixxx/build/mixxx.SlackBuild b/mixxx/build/mixxx.SlackBuild
new file mode 100755
index 00000000..ca729674
--- /dev/null
+++ b/mixxx/build/mixxx.SlackBuild
@@ -0,0 +1,257 @@
+#!/bin/sh
+# $Id$
+# Copyright 2020 Eric Hameleers, Eindhoven. NL
+# All rights reserved.
+#
+# Permission to use, copy, modify, and distribute this software for
+# any purpose with or without fee is hereby granted, provided that
+# the above copyright notice and this permission notice appear in all
+# copies.
+#
+# THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
+# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
+# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
+# USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
+# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
+# OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+# -----------------------------------------------------------------------------
+#
+# Slackware SlackBuild script
+# ===========================
+# By: Eric Hameleers <alien@slackware.com>
+# For: mixxx
+# Descr: DJ software
+# URL: https://mixxx.org/
+# Build needs:
+# Needs: chromaprint faad2 hidapi libmodplug libmp4v2 libshout lilv
+# lv2 opencore-amr portmidi portaudio protobuf qtkeychain
+# rubberband vamp-plugin-sdk
+# Changelog:
+# 2.2.4-1: 28/Jun/2020 by Eric Hameleers <alien@slackware.com>
+# * Initial build.
+#
+# Run 'sh mixxx.SlackBuild' to build a Slackware package.
+# The package (.t?z) and .txt file as well as build logs are created in /tmp .
+# Install the package using 'installpkg' or 'upgradepkg --install-new'.
+#
+# -----------------------------------------------------------------------------
+
+PRGNAM=mixxx
+VERSION=${VERSION:-2.2.4}
+BUILD=${BUILD:-1}
+TAG=${TAG:-alien}
+
+DOCS="CHANGELOG CODE_OF_CONDUCT.md COPYING LICENSE Mixxx-Manual.pdf README*"
+
+# Where do we look for sources?
+SRCDIR=$(cd $(dirname $0); pwd)
+
+# Place to build (TMP) package (PKG) and output (OUTPUT) the program:
+TMP=${TMP:-/tmp/build}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+SOURCE="$SRCDIR/${PRGNAM}-release-${VERSION}.tar.gz"
+SRCURL="https://github.com/${PRGNAM}dj/${PRGNAM}/archive/release-${VERSION}.tar.gz"
+
+##
+## --- with a little luck, you won't have to edit below this point --- ##
+##
+
+# Automatically determine the architecture we're building on:
+if [ -z "$ARCH" ]; then
+ case "$(uname -m)" in
+ i?86) ARCH=i586 ;;
+ arm*) readelf /usr/bin/file -A | egrep -q "Tag_CPU.*[4,5]" && ARCH=arm || ARCH=armv7hl ;;
+ # Unless $ARCH is already set, use uname -m for all other archs:
+ *) ARCH=$(uname -m) ;;
+ esac
+ export ARCH
+fi
+# Set CFLAGS/CXXFLAGS and LIBDIRSUFFIX:
+case "$ARCH" in
+ i?86) SLKCFLAGS="-O2 -march=${ARCH} -mtune=i686"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ;;
+ x86_64) SLKCFLAGS="-O2 -fPIC"
+ SLKLDFLAGS="-L/usr/lib64"; LIBDIRSUFFIX="64"
+ ;;
+ armv7hl) SLKCFLAGS="-O2 -march=armv7-a -mfpu=vfpv3-d16"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ;;
+ *) SLKCFLAGS=${SLKCFLAGS:-"-O2"}
+ SLKLDFLAGS=${SLKLDFLAGS:-""}; LIBDIRSUFFIX=${LIBDIRSUFFIX:-""}
+ ;;
+esac
+
+case "$ARCH" in
+ arm*) TARGET=$ARCH-slackware-linux-gnueabi ;;
+ *) TARGET=$ARCH-slackware-linux ;;
+esac
+
+# Exit the script on errors:
+set -e
+trap 'echo "$0 FAILED at line ${LINENO}" | tee $OUTPUT/error-${PRGNAM}.log' ERR
+# Catch unitialized variables:
+set -u
+P1=${1:-1}
+
+# Save old umask and set to 0022:
+_UMASK_=$(umask)
+umask 0022
+
+# Create working directories:
+mkdir -p $OUTPUT # place for the package to be saved
+mkdir -p $TMP/tmp-$PRGNAM # location to build the source
+mkdir -p $PKG # place for the package to be built
+rm -rf $PKG/* # always erase old package's contents
+rm -rf $TMP/tmp-$PRGNAM/* # remove the remnants of previous build
+rm -rf $OUTPUT/{checkout,configure,make,install,error,makepkg,patch}-$PRGNAM.log
+ # remove old log files
+
+# Source file availability:
+if ! [ -f ${SOURCE} ]; then
+ echo "Source '$(basename ${SOURCE})' not available yet..."
+ # Check if the $SRCDIR is writable at all - if not, download to $OUTPUT
+ [ -w "$SRCDIR" ] || SOURCE="$OUTPUT/$(basename $SOURCE)"
+ if [ -f ${SOURCE} ]; then echo "Ah, found it!"; continue; fi
+ if ! [ "x${SRCURL}" == "x" ]; then
+ echo "Will download file to $(dirname $SOURCE)"
+ wget --no-check-certificate -nv -T 20 -O "${SOURCE}" "${SRCURL}" || true
+ if [ $? -ne 0 -o ! -s "${SOURCE}" ]; then
+ echo "Downloading '$(basename ${SOURCE})' failed... aborting the build."
+ mv -f "${SOURCE}" "${SOURCE}".FAIL
+ exit 1
+ fi
+ else
+ echo "File '$(basename ${SOURCE})' not available... aborting the build."
+ exit 1
+ fi
+fi
+
+if [ "$P1" == "--download" ]; then
+ echo "Download complete."
+ exit 0
+fi
+
+# --- PACKAGE BUILDING ---
+
+echo "++"
+echo "|| $PRGNAM-$VERSION"
+echo "++"
+
+cd $TMP/tmp-$PRGNAM
+echo "Extracting the source archive(s) for $PRGNAM..."
+tar -xvf ${SOURCE}
+cd ${PRGNAM}-release-${VERSION}
+
+# See https://github.com/mixxxdj/mixxx/commit/03fad27
+cat $SRCDIR/patches/mixxx_list-fix.patch \
+ 2>&1 | tee $OUTPUT/patch-${PRGNAM}.log
+
+chown -R root:root .
+chmod -R u+w,go+r-w,a+rX-st .
+
+echo Building ...
+# Fix library installation path (thanks to SBo):
+sed -i "s|'lib'|'lib$LIBDIRSUFFIX'|" build/depends.py src/SConscript
+sed -i "s|usr/lib|usr/lib$LIBDIRSUFFIX|" src/SConscript
+
+# Scons is now python3 based (thanks ponce, this was really bugging me!):
+sed -i "s|from features|from .features|" build/depends.py
+
+# Scons ignores MAKEFLAGS and will autodetect your cores. If you want
+# a custom parallellization, change this setting:
+export SCONSFLAGS="-j $(nproc)"
+
+CFLAGS="$SLKCFLAGS" \
+LDFLAGS="$SLKLDFLAGS" \
+QTDIR=/usr/lib$LIBDIRSUFFIX/qt5 \
+scons \
+ build=release \
+ prefix=/usr \
+ target=linux \
+ faad=1 \
+ ffmpeg=1 \
+ lilv=1 \
+ modplug=1 \
+ opus=1 \
+ qt_sqlite_plugin=0 \
+ qtkeychain=1 \
+ shoutcast=1 \
+ test=0 \
+ vamp=1 \
+ virtualize=0 \
+ wv=1 \
+ 2>&1 | tee $OUTPUT/make-${PRGNAM}.log
+
+scons install \
+ prefix=/usr \
+ install_root=$PKG/usr \
+ 2>&1 | tee $OUTPUT/install-${PRGNAM}.log
+
+# Add this to the doinst.sh:
+mkdir -p $PKG/install
+cat <<EOINS >> $PKG/install/doinst.sh
+# Update the desktop database:
+if [ -x usr/bin/update-desktop-database ]; then
+ chroot . /usr/bin/update-desktop-database usr/share/applications > /dev/null 2>&1
+fi
+
+# Update hicolor theme cache:
+if [ -d usr/share/icons/hicolor ]; then
+ if [ -x /usr/bin/gtk-update-icon-cache ]; then
+ chroot . /usr/bin/gtk-update-icon-cache -f -t usr/share/icons/hicolor 1> /dev/null 2> /dev/null
+ fi
+fi
+
+# Update the mime database:
+if [ -x usr/bin/update-mime-database ]; then
+ chroot . /usr/bin/update-mime-database usr/share/mime >/dev/null 2>&1
+fi
+
+EOINS
+
+# Add documentation:
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a $DOCS $PKG/usr/doc/$PRGNAM-$VERSION || true
+cat $SRCDIR/$(basename $0) > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+chown -R root:root $PKG/usr/doc/$PRGNAM-$VERSION
+find $PKG/usr/doc -type f -exec chmod 644 {} \;
+
+# And remove the redundant docs:
+rm -rf $PKG/usr/share/doc
+
+# Compress the man page(s):
+if [ -d $PKG/usr/man ]; then
+ find $PKG/usr/man -type f -name "*.?" -exec gzip -9f {} \;
+ for i in $(find $PKG/usr/man -type l -name "*.?") ; do ln -s $( readlink $i ).gz $i.gz ; rm $i ; done
+fi
+
+# Strip binaries (if any):
+find $PKG | xargs file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+# Add a package description:
+mkdir -p $PKG/install
+cat $SRCDIR/slack-desc > $PKG/install/slack-desc
+cat $SRCDIR/slack-required > $PKG/install/slack-required
+
+# Build the package:
+cd $PKG
+makepkg --linkadd y --chown n $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-tgz} 2>&1 | tee $OUTPUT/makepkg-${PRGNAM}.log
+cd $OUTPUT
+md5sum ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-tgz} > ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-tgz}.md5
+cd -
+cat $PKG/install/slack-desc | grep "^${PRGNAM}" > $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.txt
+cat $PKG/install/slack-required > $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.dep
+
+# Restore the original umask:
+umask ${_UMASK_}
+
diff --git a/mixxx/build/patches/mixxx_list-fix.patch b/mixxx/build/patches/mixxx_list-fix.patch
new file mode 100644
index 00000000..df5e04bb
--- /dev/null
+++ b/mixxx/build/patches/mixxx_list-fix.patch
@@ -0,0 +1,27 @@
+From 03fad27e1f0f18ec83c9a4bc5f03f28948cd44fb Mon Sep 17 00:00:00 2001
+From: Jan Holthuis <jan.holthuis@ruhr-uni-bochum.de>
+Date: Fri, 23 Aug 2019 15:26:21 +0200
+Subject: [PATCH] scons: Fix UIC invocation via map() in Python 3
+
+---
+ build/depends.py | 6 +++++-
+ 1 file changed, 5 insertions(+), 1 deletion(-)
+
+diff --git a/build/depends.py b/build/depends.py
+index bf81d20cb89..152a6de5c11 100644
+--- a/build/depends.py
++++ b/build/depends.py
+@@ -1297,7 +1297,11 @@ def sources(self, build):
+ 'src/preferences/dialog/dlgprefvinyldlg.ui',
+ 'src/preferences/dialog/dlgprefwaveformdlg.ui',
+ ]
+- map(Qt.uic(build), ui_files)
++
++ # In Python 3.x, map() returns a "map object" (instead of a list),
++ # which is evaluated on-demand rather than at once. To invoke uic
++ # for all *.ui files at once, we need to cast it to a list here.
++ list(map(Qt.uic(build), ui_files))
+
+ if build.platform_is_windows:
+ # Add Windows resource file with icons and such
+
diff --git a/mixxx/build/slack-desc b/mixxx/build/slack-desc
new file mode 100644
index 00000000..98048a5a
--- /dev/null
+++ b/mixxx/build/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description. Line
+# up the first '|' above the ':' following the base package name, and the '|'
+# on the right side marks the last column you can put a character in. You must
+# make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+mixxx: mixxx (DJ software)
+mixxx:
+mixxx: Mixxx is a DJ Automation and digital DJ performance application.
+mixxx: It natively supports advanced MIDI and HID DJ controllers, with
+mixxx: mappings available for many DJ controllers and a wizard to create
+mixxx: custom mappings, Mixxx supports harmonic mixing and beatmatching,
+mixxx: both manually and automatically. Mixxx can read most popular free
+mixxx: audio formats, including MP3, Vorbis, Opus, AIFF and FLAC, with a
+mixxx: plug-in system to be able to read other formats.
+mixxx: It can use LV2 plugins for effects.
+mixxx: See also: https://mixxx.org/
diff --git a/mixxx/build/slack-required b/mixxx/build/slack-required
new file mode 100644
index 00000000..b8a2d019
--- /dev/null
+++ b/mixxx/build/slack-required
@@ -0,0 +1,13 @@
+chromaprint
+faad2
+hidapi
+libmodplug
+libmp4v2
+lilv
+lv2
+portmidi
+portaudio
+protobuf
+qtkeychain
+rubberband
+vamp-plugin-sdk